# hdoc

Emula um dos usos do mecanismo de "here doc" (didático). Equivale à linhas de comando como:

```
     here document
     ↓
cat << END > arquivo
```

Mas...

- Não utiliza uma palavra de término (termina com `Ctrl+D`);
- Por padrão, escreve apenas em novos arquivos (termina com erro se o arquivo existir);
- Com opções, a sobrescrita ou o *append* de arquivos existentes pode ser forçada.

## Como utilizar

```
Here Document (hdoc) 0.1

Uso: hdoc [OPÇÕES] ARQUIVO

Sem OPÇÕES, cria um novo ARQUIVO para receber linhas
digitadas no terminal.

OPÇÕES:
    -o    Força abertura de ARQUIVO para sobrescrevê-lo.
    -a    Força abertura de ARQUIVO para append.
    -h    Exibe esta ajuda.
```

## Como baixar e compilar

No diretório da sua escolha, clone este repositório:

```
:~$ git clone https://bolha.dev/blau_araujo/hdoc.git
```

O programa está no diretório `src`:

```
src
├── args-parser.c
├── args-parser.h
├── hdoc.c
├── messages.c
└── messages.h
```

Entre nele e compile com o comando abaixo:

```
:~$ cd hdoc/src
:~/hdoc/src$ gcc -Wall -Wextra hdoc.c messages.c args-parser.c -o hdoc
```

O executável `hdoc`  pode ser testado com:

```
:~/hdoc/src$ ./hdoc -h
```

## Importante!

Este programa é apenas um exemplo didático para as pessoas que estão aprendendo C com o [Curso Básico da Linguagem C](https://www.youtube.com/playlist?list=PLXoSGejyuQGrDX08GVrQHAhh4j3KJ4iYN) e contém: use por sua conta e risco!

